/*
 *	@(#)RandomColorCube.java 1.2 00/02/10 13:14:49
 *
 * Copyright (c) 1996-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Sun grants you ("Licensee") a non-exclusive, royalty free, license to use,
 * modify and redistribute this software in source and binary code form,
 * provided that i) this copyright notice and license appear on all copies of
 * the software; and ii) Licensee does not utilize the software in a manner
 * which is disparaging to Sun.
 *
 * This software is provided "AS IS," without a warranty of any kind. ALL
 * EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY
 * IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NON-INFRINGEMENT, ARE HEREBY EXCLUDED. SUN AND ITS LICENSORS SHALL NOT BE
 * LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING
 * OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL SUN OR ITS
 * LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT,
 * INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
 * CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF
 * OR INABILITY TO USE SOFTWARE, EVEN IF SUN HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES.
 *
 * This software is not designed or intended for use in on-line control of
 * aircraft, air traffic, aircraft navigation or aircraft communications; or in
 * the design, construction, operation or maintenance of any nuclear
 * facility. Licensee represents and warrants that it will not use or
 * redistribute the Software for such purposes.
 */

import javax.media.j3d.*;
import javax.vecmath.*;

class RandomColorCube extends QuadArray {
  RandomColorCube() {
    super(24, GeometryArray.COORDINATES | GeometryArray.COLOR_3);

    Point3f verts[] = new Point3f[8];
    Color3f colors[] = new Color3f[3];
	
    verts[0] = new Point3f(0.5f, 0.5f,  0.5f);
    verts[1] = new Point3f(-0.5f, 0.5f, 0.5f);
    verts[2] = new Point3f(-0.5f,-0.5f, 0.5f);
    verts[3] = new Point3f( 0.5f,-0.5f, 0.5f);
    verts[4] = new Point3f( 0.5f, 0.5f,-0.5f);
    verts[5] = new Point3f( -0.5f, 0.5f,-0.5f);
    verts[6] = new Point3f( -0.5f,-0.5f,-0.5f);
    verts[7] = new Point3f( 0.5f,-0.5f,-0.5f);
	
    colors[0] = new Color3f(1.0f, 0.0f, 0.0f);
    colors[1] = new Color3f(0.0f, 1.0f, 0.0f);
    colors[2] = new Color3f(0.0f, 0.0f, 1.0f);

    Point3f pnts[] = new Point3f[24];
    Color3f clrs[] = new Color3f[24];

    pnts[0] = verts[0];
    clrs[0] = colors[(int)(Math.random()*3.0)];
    pnts[1] = verts[3];
    clrs[1] = colors[(int)(Math.random()*3.0)];
    pnts[2] = verts[7];
    clrs[2] = colors[(int)(Math.random()*3.0)];
    pnts[3] = verts[4];
    clrs[3] = colors[(int)(Math.random()*3.0)];

    pnts[4] = verts[1];
    clrs[4] = colors[(int)(Math.random()*3.0)];
    pnts[5] = verts[5];
    clrs[5] = colors[(int)(Math.random()*3.0)];
    pnts[6] = verts[6];
    clrs[6] = colors[(int)(Math.random()*3.0)];
    pnts[7] = verts[2];
    clrs[7] = colors[(int)(Math.random()*3.0)];

    pnts[8]  = verts[0];
    clrs[8]  = colors[(int)(Math.random()*3.0)];
    pnts[9]  = verts[4];
    clrs[9]  = colors[(int)(Math.random()*3.0)];
    pnts[10] = verts[5];
    clrs[10] = colors[(int)(Math.random()*3.0)];
    pnts[11] = verts[1];
    clrs[11] = colors[(int)(Math.random()*3.0)];

    pnts[12] = verts[3];
    clrs[12] = colors[(int)(Math.random()*3.0)];
    pnts[13] = verts[2];
    clrs[13] = colors[(int)(Math.random()*3.0)];
    pnts[14] = verts[6];
    clrs[14] = colors[(int)(Math.random()*3.0)];
    pnts[15] = verts[7];
    clrs[15] = colors[(int)(Math.random()*3.0)];

    pnts[16] = verts[0];
    clrs[16] = colors[(int)(Math.random()*3.0)];
    pnts[17] = verts[1];
    clrs[17] = colors[(int)(Math.random()*3.0)];
    pnts[18] = verts[2];
    clrs[18] = colors[(int)(Math.random()*3.0)];
    pnts[19] = verts[3];
    clrs[19] = colors[(int)(Math.random()*3.0)];

    pnts[20] = verts[7];
    clrs[20] = colors[(int)(Math.random()*3.0)];
    pnts[21] = verts[6];
    clrs[21] = colors[(int)(Math.random()*3.0)];
    pnts[22] = verts[5];
    clrs[22] = colors[(int)(Math.random()*3.0)];
    pnts[23] = verts[4];
    clrs[23] = colors[(int)(Math.random()*3.0)];


    setCoordinates(0, pnts);
    setColors(0, clrs);
  }
}
